% SCRIPT_plot_results
clear variables
clc

%setup
name = 'wlan_optimization_results';
omega=3e9:0.01e9:9e9;
omega=omega/1e9;
load(name)
kol={'-','--','-.',':','o'};
count=1;

%description
fields=fieldnames(info.par);
fprintf('Description: \n')
fprintf('%s \n\n',info.descr)
for k=1:length(fields)
    fprintf('%s: \n',(fields{k}))
    fprintf('%s \n\n',info.par.(fields{k}))
end

%plot results
for k=[2 4 6 8 9]
    R0=20*log10(abs(archive{k}{1}{6}{1}));
    if k==2
        R1=20*log10(abs(archive{k}{end}{5}{1}));
    else
        R1=20*log10(abs(archive{k}{end}{6}{1}));
    end
    if count<5
        plot(omega,R0,kol{count},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
        plot(omega,R1,kol{count},'color','k','linewidth',2);
    else
        plot(omega(1:5:end),R0(1:5:end),kol{count},'color',[153 153 153]/255,'markersize',3); hold on; grid on
        plot(omega(1:5:end),R1(1:5:end),kol{count},'color','k','markersize',3);
    end    
    count=count+1;
end
plot([5 6],[-40 -40],'r','linewidth',3)
hold off
axis([3.5 7.5 -40 0])

xlabel({'Frequency [GHz]'});
ylabel({'{\it{\bf{R}}}({\bf{\it{x}}}) [dB]'});
