% SCRIPT_plot_results
clear variables
clc

% select dataset
dataset = 3;
% 1 - spline monopole - plot initial and optimized designs
% 2 - spline monopole - compare simulation/measurements patterns
% 3 - spline monopole - simulation/measurements reflection


close all
switch dataset
    case 1
        %setup
        name = 'monopole_optimization_results_2';
        omega=2e9:0.1e9:12e9;
        omega=omega/1e9;
        load(name)
        kol={'-','--','-.',':','o'};
        
        %description
        clc
        fields=fieldnames(info.par);
        fprintf('Description: \n')
        fprintf('%s \n\n',info.descr)
        for k=1:length(fields)
            fprintf('%s: \n',(fields{k}))
            fprintf('%s \n\n',info.par.(fields{k}))
        end
        
        %plot results       
        R0=20*log10(abs(archive{1}{5}{1}));
        R1=20*log10(abs(archive{end}{6}{1}));
        
        plot(omega(1:end-1),R0(1:end-1),kol{1},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
        plot(omega(1:end-1),R1(1:end-1),kol{1},'color','k','linewidth',2);
        plot([3.1 10.6],[-20 -20],'r','linewidth',3)        
        legend('Initial','Optimized')
        hold off
        axis([2 12 -20 0])
        
        xlabel({'Frequency [GHz]'});
        ylabel({'{\it{\bf{R}}}({\bf{\it{x}}}) [dB]'});
        
    case 2
        %setup
        name='monopole_experiment_radiation_pattern_2';
        load(name);
        kol={'-','--','-.',':','o'};
        
        %description
        clc
        fields=fieldnames(info.par);
        fprintf('Description: \n')
        fprintf('%s \n\n',info.descr)
        for k=1:length(fields)
            fprintf('%s: \n',(fields{k}))
            fprintf('%s \n\n',info.par.(fields{k}))
        end
        
        %plot results
        for k=1:4
            figure
            dirplot_v3(pattern(k).ang,pattern(k).EMsim,{kol{1},'Color',[153 153 153]/255,'LineWidth',2,'MarkerSize',3},[0 -20 2 45],16); hold on            
            dirplot_v3(pattern(k).ang,pattern(k).meas,{kol{1},'Color','k','LineWidth',2,'MarkerSize',3},[0 -20 2 45],16); hold off            
            legend(['Simulation','f_0 = ',num2str(strrep(pattern(k).f0,'_','.')),' GHz'],'Measurement')
        end
    case 3
        %setup
        name = 'monopole_experiment_reflection_2';        
        load(name)
        kol={'-','--','-.',':','o'};
        
        %description
        clc
        fields=fieldnames(info.par);
        fprintf('Description: \n')
        fprintf('%s \n\n',info.descr)
        for k=1:length(fields)
            fprintf('%s: \n',(fields{k}))
            fprintf('%s \n\n',info.par.(fields{k}))
        end
        
        %plot results        
        plot(S11.sim.omega,S11.sim.resp,kol{1},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
        plot(S11.meas.omega,S11.meas.resp,kol{1},'color','k','linewidth',2);  
        legend('Simulation','Measurement')
        hold off
        axis([2 12 -25 0])
        
        xlabel({'Frequency [GHz]'});
        ylabel({'{\it{\bf{R}}}({\bf{\it{x}}}) [dB]'});
end