% SCRIPT_plot_results
clear variables

picture = 1; % step-size dilemma
% picture = 2; % numerical noise
% picture = 3; % optimization flow
% picture = 4; % perturbations - function response vs objective function change
% picture = 5; % bar graphs - adjust step size using heuristic
% picture = 6; % bar graphs - reset surrogate
% picture = 7; % ISM antenna - plot initial and optimized designs
% picture = 8; % UWB antenna - plot initial and optimized designs
% picture = 9; % UWB antenna - plot radiation characteristics
picture = 10; % rectifier - plot initial and optimized designs
% picture = 11; % discussion - data
% picture = 12; % localization measurements
% picture = 13; % UWB antenna - compare simulation/measurements patterns
% picture = 14; % UWB antenna - simulation/measurements reflection

fontsize=16; close all
%fix gray x/y labels
set(groot,{'DefaultAxesXColor','DefaultAxesYColor','DefaultAxesZColor'},{'k','k','k'})
switch picture
    case 1
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*8.9 2*5])
        
        
        x=(pi/3);
        N=50;
        p=single(linspace(-7,0,N));
        h=single(10.^p);
        FD=zeros(N,1); df = FD; df1=FD;
        for k=1:N
            FD(k)=single((sin(x+h(k))-sin(x))/h(k));
            %     df(k)=single(cos(x+h(k)));
            df1(k)=single(cos(x));
        end
        % f=single(abs(FD-df));
        fs=single(abs(FD-df1));
        hs=h;
        [~,idxs]=(min(fs)); %idxs=idxs+4;
        
        N=2*N;
        p=(linspace(-15,0,N));
        h=(10.^p);
        FD=zeros(N,1); df = FD; df1=FD;
        for k=1:N
            FD(k)=((sin(x+h(k))-sin(x))/h(k));
            %     df(k)=(cos(x+h(k)));
            df1(k)=(cos(x));
        end
        % f=single(abs(FD-df));
        fd=single(abs(FD-df1));
        hd=h;
        [~,idxd]=(min(fd)); %idxd=idxd+3;
        
        
        
        
        loglog(hd(1:idxd-1),fd(1:idxd-1),'ko','markersize',5); grid on; hold on
        loglog(hd(idxd:end),fd(idxd:end),'o','color',[153 153 153]/255,'markersize',5);
        loglog(hs(1:idxs-1),fs(1:idxs-1),'kd','markersize',5);
        loglog(hs(idxs:end),fs(idxs:end),'d','color',[153 153 153]/255,'markersize',5);
        hold off
        axis([1e-15 1e0 1e-9 1e0])
        
        % set(gca,'xtick',0:0.5:7)
        hX=xlabel({'Finite-difference step size'});
        % hY=ylabel({'|{\it{\bf{P}}''}({\bf{\it{x}}}) -
        % \it{\Delta}{\it{\bf{P}}}({\bf{\it{x}}})|'});
        hY=ylabel({'|{\it{\bf{O}}}({\bf{\it{h}}})|'});
        
        
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
    case 2
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*8.9 2*5])
        
        load noise1
        N=200;
        x=linspace(-0.5,1,N);
        sigma0=0.2; mi0=-0.4;
        sigma1=0.1; mi1=-0.0;
        sigma2=0.1; mi2=0.4;
        sigma3=0.3; mi3=1;
        g0=1/(sigma0*(2*pi)^0.5)*exp((-(x-mi0).^2)/(2*sigma0^2));
        g1=1/(sigma1*(2*pi)^0.5)*exp((-(x-mi1).^2)/(2*sigma1^2));
        g2=1/(sigma2*(2*pi)^0.5)*exp((-(x-mi2).^2)/(2*sigma2^2));
        g3=1/(sigma3*(2*pi)^0.5)*exp((-(x-mi3).^2)/(2*sigma3^2));
        go=-g0+g1+g2/1.5-g3;
        go=go/max(abs(go));
        %         y=rand(1,N/2)/5; y1=zeros(N,1); y1(1:2:end)=y;
        %         y1(2:2:end)=y; y1=y1';
        
        X=(x+0.5)/1.5; Y=-go+y1;
        
        [a,b0]=min(abs(X-0.1357));
        b1=b0+4;
        [a,b2]=min(abs(X-0.2109));
        [a,b3]=min(abs(X-0.4724));
        p1=polyfit(X([b0,b1]),Y([b0,b1]),1);
        p2=polyfit(X([b0,b2]),Y([b0,b2]),1);
        p3=polyfit(X([b0,b3]),Y([b0,b3]),1);
        FD1=polyval(p1,X(b0:end));
        FD2=polyval(p2,X(b0:end));
        FD3=polyval(p3,X(b0:end));
        plot(X(b0),Y(b0),'ro','markerfacecolor','r'); hold on; grid on
        plot(X(b1),Y(b1),'rs','markerfacecolor','r');
        plot(X(b2),Y(b2),'rd','markerfacecolor','r');
        plot(X(b3),Y(b3),'rv','markerfacecolor','r');
        plot(X,Y,'k','linewidth',2); hold on; grid on
        plot(X(b0:end),FD1,':','color',[153 153 153]/255,'linewidth',2)
        plot(X(b0:end),FD2,'-','color',[153 153 153]/255,'linewidth',2)
        plot(X(b0:end),FD3,'--','color',[153 153 153]/255,'linewidth',2)
        plot(X(b0),Y(b0),'ro','markerfacecolor','r');
        plot(X(b1),Y(b1),'rs','markerfacecolor','r');
        plot(X(b2),Y(b2),'rd','markerfacecolor','r');
        plot(X(b3),Y(b3),'rv','markerfacecolor','r');
        hold off
        
        legend('{\it{x}}^{(0)}','{\it{x}}^{(0)}+{\it{h}}^{(1)}','{\it{x}}^{(0)}+{\it{h}}^{(2)}','{\it{x}}^{(0)}+{\it{h}}^{(3)}')
        axis([0 1 -1 1])
        hX=xlabel({'{\it{{x}}}'});
        % hY=ylabel({'|{\it{\bf{P}}''}({\bf{\it{x}}}) -
        % \it{\Delta}{\it{\bf{P}}}({\bf{\it{x}}})|'});
        hY=ylabel({'Objective function'});
        
        
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
        %         y=5*rand(1,N); f =((x.*6-2).^2).*sin((x.*6-2).*2)+y;
        %         plot(x-0.5,f/max(f))
    case 3
        name = 'numerical_tests_fine_percent_x0_cost_';
        %         idx={'005','010','015','020','025','030'};
        idx={'005','010','015','020'};
        %         idx={'005','010','020','030'}; idx={'005','015','025'};
        name1='numerical_tests_fine_sqrt_precision_cost';
        kol={'k-','k--','k:','k-.'};
        i00=[6,9];
        for jj=1:length(i00)
            i0=i00(jj);
            hFig=figure;
            set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
            normy=[];
            normx=[];
            rho=[];
            for k=1:length(idx)+1
                if k<=length(idx)
                    load([name,idx{k}])
                else
                    load(name1)
                end
                for ii=1:length(archive{i0})
                    normy{k}(ii)=archive{i0}{ii}{4};
                    rho{k}(ii)=archive{i0}{ii}{2};
                    normx{k}(ii)=archive{i0}{ii}{1};
                end
                [~,id]=min(normx{k});
                %                 id=length(normx{k}); if k<=length(idx)
                %                     plot(normx{k}(1:id),kol{k},'linewidth',2);
                %                     hold on
                %                 else
                %                     plot(normx{k}(1:id),'-','color',[153
                %                     153 153]/255,'linewidth',2); hold on
                %                 end
                x=ones(size(rho{k}));
                x(rho{k}>0)=7;
                %x(1)=1;
                %x(2)=6;
                x(1)=7;
                if length(x)==16
                    x(end)=1;
                end
                x=cumsum(x);
                normy{k}(1)=1;
                if k<=length(idx)
                    semilogy(x(1:id),normy{k}(1:id),kol{k},'linewidth',2); hold on
                else
                    semilogy(x(1:id),normy{k}(1:id),'-','color',[153 153 153]/255,'linewidth',2); hold on
                end
                
                %             semilogy(normx{k}); hold on
            end
            if jj==1
                set(gca,'Xtick',10:20:200)
            else
                set(gca,'Xtick',10:15:200)
            end
            grid on; hold off
            axis([-Inf Inf 10^-2 10^0.1])
            %             legend('{\bf{\it{h}}}=0.005{\bf{\it{x}}}_1^{(0)}','{\bf{\it{h}}}=0.010{\bf{\it{x}}}_1^{(0)}','{\bf{\it{h}}}=0.015{\bf{\it{x}}}_1^{(0)}','{\bf{\it{h}}}=0.020{\bf{\it{x}}}_1^{(0)}','{\bf{\it{h}}}=10^{-7\cdot0.5}{\bf{\it{1}}}')
            
            hX=xlabel({'Number of EM simulations'});
            % hY=ylabel({'|{\it{\bf{P}}''}({\bf{\it{x}}}) -
            % \it{\Delta}{\it{\bf{P}}}({\bf{\it{x}}})|'});
            % hY=ylabel({'Objective function change'});
            if jj==1
                hY=ylabel({'||{\bf{\it{x}}}_6^{({\it{i}}+1)}-{\bf{\it{x}}}_6^{({\it{i}})}||'});
            else
                hY=ylabel({'||{\bf{\it{x}}}_9^{({\it{i}}+1)}-{\bf{\it{x}}}_9^{({\it{i}})}||'});
            end
            
            
            
            set(gca,'FontSize',fontsize)
            set(gca,'FontName','Times New Roman')
            set([hY,hX],'FontSize',fontsize)
            set([hY,hX],'FontName','Times New Roman')
        end
    case 4
        name = 'perturbations_d01_x8';
        load(name)
        idx=[2,5];
        for jj=1:2
            hFig=figure;
            set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
            stp=3;
            w=omega/1e9;
            w2=w-stp*0.01;
            R1=20*log10(abs(Rtmp{1}{1}));
            R2=20*log10(abs(Rtmp{idx(jj)}{1}));
            R2i=interp1(w,R2,w2,'pchip');
            
            plot(w,R1,'k','linewidth',2); hold on; grid on
            plot(w,R2i,'color',[153 153 153]/255,'linewidth',2);
            E0=max(R1(381:481));
            E1=max(R2i(381:481));
            E=E0-E1;
            disp([E0 E1 E]);
            plot([6.8 7.8],[E0 E0],'b','linewidth',2)
            plot([6.8 7.8],[E1 E1],'r','linewidth',2); hold off
            
            
            hX=xlabel({'Frequency [GHz]'});
            hY=ylabel({'{\it{\bf{R}}}({\bf{\it{x}}}) [dB]'});
            
            axis([4 9 -6 0])
            
            set(gca,'FontSize',fontsize)
            set(gca,'FontName','Times New Roman')
            set([hY,hX],'FontSize',fontsize)
            set([hY,hX],'FontName','Times New Roman')
        end
    case 5
        %         name = 'step_adjust_';
        name = 'heur_adjust_';
        for jj=6
            load([name,num2str(jj)])
            
            hFig=figure;
            set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
            
            E0=Efd0(1)-Efd0(2:end);
            E1=Esd1(1)-Esd1(2:end);
            %             E2=Efd1(1)-Efd1(2:end); bar([E0,E1,E2])
            b=bar([E0,E1]);
            b(1).FaceColor='k';
            b(2).FaceColor=[153 153 153]/255;
            grid on
            axis([0 7 -0.1 0.1])
            
            hX=xlabel({'Parameter index'});
            hY=ylabel({'Objective function change'});
            
            set(gca,'FontSize',fontsize)
            set(gca,'FontName','Times New Roman')
            set([hY,hX],'FontSize',fontsize)
            set([hY,hX],'FontName','Times New Roman')
            
            hFig=figure;
            set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
            
            %             E0=Efd0(1)-Efd0(2:end); E1=Esd1(1)-Esd1(2:end);
            %             E2=Efd1(1)-Efd1(2:end); bar([E0,E1,E2])
            b=bar([d0,d1]);
            b(1).FaceColor='k';
            b(2).FaceColor=[153 153 153]/255;
            grid on
            axis([0 7 0 0.1])
            
            hX=xlabel({'Parameter index'});
            hY=ylabel({'Normalized perturbation size'});
            
            set(gca,'FontSize',fontsize)
            set(gca,'FontName','Times New Roman')
            set([hY,hX],'FontSize',fontsize)
            set([hY,hX],'FontName','Times New Roman')
            %             subplot(1,2,2) bar([d0,d1])
        end
    case 6
        name = 'step_adjust_';
        %         name = 'heur_adjust_';
        for jj=4
            load([name,num2str(jj)])
            
            hFig=figure;
            set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
            
            E0=Efd0(1)-Efd0(2:end);
            E1=Esd1(1)-Esd1(2:end);
            E2=Efd1(1)-Efd1(2:end);
            b=bar([E0,E1,E2]);
            %             b=bar([E0,E1]);
            b(1).FaceColor='k';
            b(2).FaceColor=[153 153 153]/255;
            b(3).FaceColor=[255 255 255]/255;
            grid on
            axis([0 7 -0.2 0.0])
            
            hX=xlabel({'Parameter index'});
            hY=ylabel({'Objective function change'});
            
            set(gca,'FontSize',fontsize)
            set(gca,'FontName','Times New Roman')
            set([hY,hX],'FontSize',fontsize)
            set([hY,hX],'FontName','Times New Roman')
            
            hFig=figure;
            set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
            
            %             E0=Efd0(1)-Efd0(2:end); E1=Esd1(1)-Esd1(2:end);
            %             E2=Efd1(1)-Efd1(2:end); bar([E0,E1,E2])
            b=bar([d0,d1]);
            b(1).FaceColor='k';
            b(2).FaceColor=[153 153 153]/255;
            grid on
            axis([0 7 0 0.1])
            
            hX=xlabel({'Parameter index'});
            hY=ylabel({'Normalized perturbation size'});
            
            set(gca,'FontSize',fontsize)
            set(gca,'FontName','Times New Roman')
            set([hY,hX],'FontSize',fontsize)
            set([hY,hX],'FontName','Times New Roman')
            %             subplot(1,2,2) bar([d0,d1])
        end
    case 7
        name = 'numerical_tests_fine_adaptive_d_cost3_k';
        omega=3e9:0.01e9:9e9;
        omega=omega/1e9;
        load(name)
        kol={'-','--','-.',':','o'};
        count=1;
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*9 2*5])
        
        for k=[2 4 6 8 9]
            R0=20*log10(abs(archive{k}{1}{6}{1}));
            if k==2
                R1=20*log10(abs(archive{k}{end}{5}{1}));
            else
                R1=20*log10(abs(archive{k}{end}{6}{1}));
            end
            if count<5
                plot(omega,R0,kol{count},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
                plot(omega,R1,kol{count},'color','k','linewidth',2);
            else
                plot(omega(1:5:end),R0(1:5:end),kol{count},'color',[153 153 153]/255,'markersize',3); hold on; grid on
                plot(omega(1:5:end),R1(1:5:end),kol{count},'color','k','markersize',3);
            end
            count=count+1;
        end
        plot([5 6],[-40 -40],'r','linewidth',3)
        hold off
        axis([3.5 7.5 -40 0])
        
        hX=xlabel({'Frequency [GHz]'});
        hY=ylabel({'{\it{\bf{R}}}({\bf{\it{x}}}) [dB]'});
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
    case 8
        name = 'spline_opt_adaptive_perturbations';
        omega=2e9:0.1e9:12e9;
        omega=omega/1e9;
        load(name)
        kol={'-','--','-.',':','o'};
        
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*9 2*5])
        
        R0=20*log10(abs(archive{1}{5}{1}));
        R1=20*log10(abs(archive{end}{6}{1}));
        
        plot(omega(1:end-1),R0(1:end-1),kol{1},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
        plot(omega(1:end-1),R1(1:end-1),kol{1},'color','k','linewidth',2);
        plot([3.1 10.6],[-20 -20],'r','linewidth',3)
        
        
        hold off
        axis([2 12 -20 0])
        
        hX=xlabel({'Frequency [GHz]'});
        hY=ylabel({'{\it{\bf{R}}}({\bf{\it{x}}}) [dB]'});
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
    case 9
        name{1} = 'Gain_Phi_0_';
        name{2} = 'Gain_Teta_90_';
        idx={'4','6','8','10'};
        for k=1:4
            for jj=1:2
                f1=fopen([name{jj},idx{k},'G.rd1']);
                D=textscan(f1,'%s','delimiter','\n');
                D=D{1};
                D=D(5:end);
                tmp=cellfun(@str2num,D,'UniformOutput',0);
                data=[tmp{:}];
                data=reshape(data,2,length(data)/2)';
                R{jj}=data;
            end
            tmp=[R{1};R{2}];
            sc=max(tmp(:,2));
            R1=R{1}(:,2)-sc;
            R2=R{2}(:,2)-sc;
            R1(R1<-30)=-30;
            R2(R2<-30)=-30;
            ang=R{1}(:,1);
            R2=[R2(56:end);R2(1:55)];
            R2(1)=R2(end);

            
            hFig=figure;
            set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*4.5])
            dirplot_v3(ang,R1,{'-','Color','k','LineWidth',2,'MarkerSize',3},[0 -30 3 45],16); hold on
            dirplot_v3(ang,R2,{'-','Color',[153 153 153]/255,'LineWidth',2,'MarkerSize',3},[0 -30 3 45],16); hold on
        end
    case 10
        name = 'rectifier_opt_adaptive_perturbations';
        omega=0.1e9:0.05e9:4.5e9;
        omega=omega/1e9;
        load(name)
        kol={'-','--','-.',':','o'};
        
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
        
        R0=20*log10(abs(archive{1}{6}{1}));
        R1=20*log10(abs(archive{end}{6}{1}));
        
        plot(omega(1:end-1),R0(1:end-1),kol{1},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
        plot(omega(1:end-1),R1(1:end-1),kol{1},'color','k','linewidth',2);
        plot([0.5 3.5],[-20 -20],'r','linewidth',3)
        hold off
        axis([0.1 4 -20 0])
        
        hX=xlabel({'Frequency [GHz]'});
        hY=ylabel({'{\it{\bf{R}}}_1({\bf{\it{x}}}) [dB]'});
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
        
        R0=20*log10(abs(archive{1}{6}{2}));
        R1=20*log10(abs(archive{end}{6}{2}));
        
        plot(omega(1:end-1),R0(1:end-1),kol{1},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
        plot(omega(1:end-1),R1(1:end-1),kol{1},'color','k','linewidth',2);
        plot([0.5 3.5],[20 20],'r','linewidth',3)
        hold off
        axis([0.1 4 20 40])
        
        hX=xlabel({'Frequency [GHz]'});
        hY=ylabel({'{\it{\bf{R}}}_2({\bf{\it{x}}}) [%]'});
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
    case 11
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
        %average of ISM antenna
        x1=[-27.1900  -23.8300  -24.3900  -24.2200];
        x1=10.^(x1/20);
        x1=x1/min(x1);
        % x1=1./x1;
        % x1=1./x1;
        
        %monopole
        x2=[176.2500  205.6500  225.8300  189.8100];
        x2=x2/min(x2);
        %rectifier objective functions
        x3=[7.11	7.85	10.57	7.55];
        x3=x3/min(x3);
        
        plot(-x1+2,'ko','markerfacecolor','k','markersize',8); hold on
        plot(-x2+2,'ks','markerfacecolor','k','markersize',8);
        plot(-x3+2,'kd','markerfacecolor','k','markersize',8); hold off; grid on
        
        hX=xlabel({'Method'});
        hY=ylabel({'Normalized performance'});
        
        ticks={'Proposed','(i)','(ii)','(iii)'};
        set(gca,'xtick',1:4)
        set(gca,'xticklabels',ticks)
        
        %         legend('ISM','UWB','Rectifier','location','west')
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
        axis([0.5 4.5 0.5 1])
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*5])
        
        c1=[2.95 2.24 2.23 2.61];
        c1=c1/min(c1(1));
        %         c1=c1/(c1(1));
        c2=[29.57	15.62	9.89	16.36];
        c2=c2/min(c2(1));
        c3=[34.14	32.05	8.39	43.73];
        c3=c3/min(c3(1));
        
        plot(c1,'ko','markerfacecolor','k','markersize',8); hold on
        plot(c2,'ks','markerfacecolor','k','markersize',8);
        plot(c3,'kd','markerfacecolor','k','markersize',8); hold off; grid on
        
        ticks={'Proposed','(i)','(ii)','(iii)'};
        set(gca,'xtick',1:4)
        set(gca,'ytick',0.1:0.3:2)
        set(gca,'xticklabels',ticks)
        
        legend('ISM','UWB','Rectifier','location','northwest')
        
        hX=xlabel({'Method'});
        hY=ylabel({'Normalized numerical cost'});
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
        axis([0.5 4.5 0.1 1.6])
    case 12
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*5 2*5])
        
        %generate reference points
        xy0=[2.84 2.9];
        x=0:0.75:3;
        y=[-0.75, 0];
        x=x+xy0(1);
        y=y+xy0(2);
        [x,y]=meshgrid(x,y);
        x=x'; y=y';
        xy0=[[x(:,1);flipud(x(:,2))],flipud(y(:))];
        %load measurements
        %data=load('localization_t1t2_p12.txt','-ASCII'); %stock antennas
        %data1=load('localization_t1t2_p34.txt','-ASCII'); %custom antennas
        data=load('localization_t1t2_stock_v2.txt','-ASCII'); %stock antennas
        data1=load('localization_t1t2_custom_v2.txt','-ASCII'); %custom antennas
        kol={'r','g','b','c'};
        for k=1:4
            m{k}=data((k-1)*10+1:k*10,3:4);
            m1{k}=data1((k-1)*10+1:k*10,3:4);
            plot(m{k}(:,1),m{k}(:,2),'x','color',kol{k}); hold on; grid on
            plot(m1{k}(:,1),m1{k}(:,2),'v','color',kol{k}); hold on; grid on
        end
        plot(xy0(:,1),xy0(:,2),'ko'); hold off; axis equal
        %stock antennas
        %precision - distance from average value
        mx=[];my=[];
        for k=1:4
            mx=[mx,m{k}(:,1)];
            my=[my,m{k}(:,2)];
        end
        x0=xy0(:,1); y0=xy0(:,2);
        x0=x0(:,ones(1,4)); y0=y0(:,ones(1,4));
        %amx=mean(mx,2); amy=mean(my,2);
        %mmx=max(mx,[],2); mmy=max(my,[],2);
        %df=([amx amy]-[mmx mmy]);
        %for k=1:length(df)
        %    prec(k,1)=sqrt(sum(df(k,:).^2));
        %end
        %%accuracy - distance from true value
        %aaxy=[mean(x0-mx,2), mean(y0-my,2)];
        %for k=1:length(df)
        %    accu(k,1)=sqrt(sum(aaxy(k,:).^2));
        %end
        dx=x0-mx;
        dy=y0-my;
        for k=1:4
            for jj=1:10
                dist(jj,k)=sqrt(dx(jj,k).^2+dy(jj,k).^2);
            end
        end
        %precision
        md=mean(dist,2);
        prec2=max(abs(md(:,ones(1,4))-dist),[],2);
        accu2=mean(dist,2);
        fid=fopen('uwb_rtls_benchmark_table.txt','wt');
        for k=1:10
            fprintf(fid,'%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t\n',dist(k,:)*100,accu2(k)*100,prec2(k)*100);
        end
        fprintf(fid,'%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t\n',mean(dist,1)*100,mean(accu2)*100,mean(prec2)*100);
        fprintf(fid,'%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t\n',median(dist,1)*100,median(accu2)*100,median(prec2)*100);
        fclose(fid)
        
        %custom antennas
        %precision - distance from average value
        mx=[];my=[];
        for k=1:4
            mx=[mx,m1{k}(:,1)];
            my=[my,m1{k}(:,2)];
        end
        x0=xy0(:,1); y0=xy0(:,2);
        x0=x0(:,ones(1,4)); y0=y0(:,ones(1,4));
        %amx=mean(mx,2); amy=mean(my,2);
        %mmx=max(mx,[],2); mmy=max(my,[],2);
        %df=([amx amy]-[mmx mmy]);
        %for k=1:length(df)
        %    prec(k,1)=sqrt(sum(df(k,:).^2));
        %end
        %%accuracy - distance from true value
        %aaxy=[mean(x0-mx,2), mean(y0-my,2)];
        %for k=1:length(df)
        %    accu(k,1)=sqrt(sum(aaxy(k,:).^2));
        %end
        dx=x0-mx;
        dy=y0-my;
        for k=1:4
            for jj=1:10
                dist(jj,k)=sqrt(dx(jj,k).^2+dy(jj,k).^2);
            end
        end
        %precision
        md=mean(dist,2);
        prec2=max(abs(md(:,ones(1,4))-dist),[],2);
        accu2=mean(dist,2);
        fid=fopen('uwb_rtls_benchmark_table2.txt','wt');
        for k=1:10
            fprintf(fid,'%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t\n',dist(k,:)*100,accu2(k)*100,prec2(k)*100);
        end
        fprintf(fid,'%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t\n',mean(dist,1)*100,mean(accu2)*100,mean(prec2)*100);
        fprintf(fid,'%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t%2.1f\t\n',median(dist,1)*100,median(accu2)*100,median(prec2)*100);
        fclose(fid)
    case 13
        pth='..\measurements';
        load([pth,'\simulations_EM\GainIoT_phi_sim.mat']);
        f00=[3.5,4,5,6,6.5,8,10]*1e9;
        measFil='spline_IoT_';
        measSus='GHz_phi0';
        freq={'3_5','4','5','6','6_5','8','10'};
        idx=[1 3 5 7];        
%         idx=[2 4 6 7];        
        for k=1:4
            load([pth,filesep,measFil,freq{idx(k)},measSus])
            [val,idsim]=min(abs(fSim-f00(idx(k))));
            R{1}=flipud(ffSim{idsim});
            R{2}=smooth(ffCor);
            R1=R{1}-max(R{1});            
            R2=R{2}-max(R{2});
            R1(R1<-30)=-30;
            R2(R2<-30)=-30;
            R1(end+1)=R1(1);
            R2(end+1)=R2(1);            
            ang=angMeas;
            ang(end+1)=-ang(1);
            RadPatt(k).f0=freq{idx(k)};
            RadPatt(k).ang=ang;
            RadPatt(k).meas=R1;
            RadPatt(k).EMsim=R2;
%             R2=[R2(56:end);R2(1:55)];
%             R2(1)=R2(end);
            hFig=figure;
            set(hFig,'Units','centimeters','Position', [4 4 2*4.5 2*4.5])
            dirplot_v3(ang,R1,{'-','Color','k','LineWidth',2,'MarkerSize',3},[0 -20 2 45],16); hold on
            dirplot_v3(ang,R2,{'-','Color',[153 153 153]/255,'LineWidth',2,'MarkerSize',3},[0 -20 2 45],16); hold on
        end
        save experiment_spline_monopole_gain RadPatt
    case 14
        name = 'spline_opt_adaptive_perturbations';
        omega=2e9:0.1e9:12e9;
        w=omega/1e9;
        load(name)
        load('..\measurements\reflection_spline_meas.mat')
        kol={'-','--','-.',':','o'};
        
        
        hFig=figure;
        set(hFig,'Units','centimeters','Position', [4 4 2*6 2*5])
                
        Rs=20*log10(abs(archive{end}{6}{1}));
        Rm=data(:,1);
        plot(w(1:end-1),Rs(1:end-1),kol{1},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
        plot(omega,smooth(20*log10(abs(Rm)),0.02),kol{1},'color','k','linewidth',2);
        S11.sim.omega=w(1:end-1);
        S11.sim.resp=Rs(1:end-1);
        S11.meas.omega=omega;
        S11.meas.resp=smooth(20*log10(abs(Rm)),0.02);
        save spline_monopole_experiment_reflection S11
%         plot([3.1 10.6],[-20 -20],'r','linewidth',3)
        
        
        hold off
        axis([2 12 -25 0])
        
        hX=xlabel({'Frequency [GHz]'});
        hY=ylabel({'{\it{\bf{R}}}({\bf{\it{x}}}) [dB]'});
        
        set(gca,'FontSize',fontsize)
        set(gca,'FontName','Times New Roman')
        set([hY,hX],'FontSize',fontsize)
        set([hY,hX],'FontName','Times New Roman')
end