% SCRIPT_plot_results
clear variables
clc

picture = 10; % rectifier - plot initial and optimized designs
close all

%setup
name = 'rectifier_optimization_results_2';
omega=0.1e9:0.05e9:4.5e9;
omega=omega/1e9;
load(name)
kol={'-','--','-.',':','o'};

%description
fields=fieldnames(info.par);
fprintf('Description: \n')
fprintf('%s \n\n',info.descr)
for k=1:length(fields)
    fprintf('%s: \n',(fields{k}))
    fprintf('%s \n\n',info.par.(fields{k}))
end

%plot results
R01=20*log10(abs(archive{1}{6}{1}));
R11=20*log10(abs(archive{end}{6}{1}));
R02=20*log10(abs(archive{1}{6}{2}));
R12=20*log10(abs(archive{end}{6}{2}));

subplot(1,2,1)
plot(omega(1:end-1),R01(1:end-1),kol{1},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
plot(omega(1:end-1),R11(1:end-1),kol{1},'color','k','linewidth',2);
plot([0.5 3.5],[-20 -20],'r','linewidth',3)
legend('Initial','Optimized')
hold off
axis([0.1 4 -20 0])

xlabel({'Frequency [GHz]'});
ylabel({'{\it{\bf{R}}}_1({\bf{\it{x}}}) [dB]'});

subplot(1,2,2)
plot(omega(1:end-1),R02(1:end-1),kol{1},'color',[153 153 153]/255,'linewidth',2); hold on; grid on
plot(omega(1:end-1),R12(1:end-1),kol{1},'color','k','linewidth',2);
plot([0.5 3.5],[20 20],'r','linewidth',3)
legend('Initial','Optimized')
hold off
axis([0.1 4 20 40])

hX=xlabel({'Frequency [GHz]'});
hY=ylabel({'{\it{\bf{R}}}_2({\bf{\it{x}}}) [%]'});